## sikuli 1.0~x~rc2

=== extensions/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
PROJECT (sikuli-extensions Java)

SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../cmake_modules/")
INCLUDE(${CMAKE_MODULE_PATH}/common.cmake)
FIND_PACKAGE(Java)

SET(BASE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
SET(COMMON_LIB_DIR "${BASE_DIR}/../lib")

SET(SIKULI_JAR ${COMMON_LIB_DIR}/sikuli-script.jar)
SET(CLASSPATH ${SIKULI_JAR})


### add new extensions here
SET(EXTENSIONS 
   guide
)

FOREACH(EXT ${EXTENSIONS})
   ADD_SUBDIRECTORY(${EXT})
ENDFOREACH(EXT)

=== sikuli-ide/CMakeLists.txt ===
INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/../cmake_modules/common.cmake)
INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/../cmake_modules/detect_osx_ver.cmake)
INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/../cmake_modules/find_dep_libs.cmake)

CMAKE_MINIMUM_REQUIRED(VERSION 2.8)
PROJECT (sikuli-ide Java)

ENABLE_TESTING()

SET(CMAKE_VERBOSE_MAKEFILE 0)

FIND_PACKAGE(Java)
SET( NON_NATIVE_TARGET TRUE)

IF(UNIX)
   SET(SEP ":")
ELSE()
   SET(SEP ";")
ENDIF()


SET(BASE_DIR "${CMAKE_CURRENT_SOURCE_DIR}")
SET(JAVA_SRC_DIR "${BASE_DIR}/src/main/java")
SET(NATIVE_SRC_DIR "${BASE_DIR}/src/main/native")
SET(COMMON_LIB_DIR "${BASE_DIR}/../lib")
SET(INCLUDE_LIB_DIR "${BASE_DIR}/lib")
SET(BINARY_DIR "${BASE_DIR}/target")
SET(BINARY_CLASS_DIR "${BINARY_DIR}/classes")
SET(BINARY_LIB_DIR "${BINARY_DIR}/lib")
SET(JAR_DIR "${BINARY_DIR}/jar")
SET(RESOURCE_DIR "${BASE_DIR}/resources")
SET(RELEASE_DIR "${BASE_DIR}/../release")

SET(SIKULI_SCRIPT_JAR "${COMMON_LIB_DIR}/sikuli-script.jar")
SET(JUNIT_JAR "${COMMON_LIB_DIR}/junit-3.8.1.jar")
SET(SWING_LAYOUT_JAR "${COMMON_LIB_DIR}/swing-layout-1.0.1.jar")
SET(COMMONS_CLI_JAR "${COMMON_LIB_DIR}/commons-cli-1.2.jar")
SET(JSON_SIMPLE_JAR "${COMMON_LIB_DIR}/json_simple-1.1.jar")
SET(JXGRABKEY_JAR "${COMMON_LIB_DIR}/jxgrabkey/lib/JXGrabKey.jar")
SET(JINTELLITYPE_JAR "${COMMON_LIB_DIR}/jintellitype-1.3.6/jintellitype-1.3.6.jar")
SET(SWINGX_JAR "${COMMON_LIB_DIR}/swingx-core-1.6.2.jar")
SET(MAC_WIDGETS_JAR "${COMMON_LIB_DIR}/mac_widgets.jar")
SET(FORMS_JAR "${COMMON_LIB_DIR}/forms-1.2.1.jar")


FILE(MAKE_DIRECTORY ${BINARY_DIR})
FILE(MAKE_DIRECTORY ${BINARY_CLASS_DIR})
FILE(MAKE_DIRECTORY ${JAR_DIR})

## Sikuli IDE

SET(MAIN_CLASS org.sikuli.ide.SikuliIDE)
SET(RUN_USER_ARGS -Dsikuli.console=true -Dfile.encoding=UTF-8 
             -Xms64m -Xmx512m 
   CACHE STRING 
   "The arguments for running Sikuli IDE with 'make run-user'"
)
SET(RUN_ARGS -Dsikuli.console=true -Dsikuli.Debug=3 -Dfile.encoding=UTF-8 
             -Xms64m -Xmx512m 
             #-Duser.language=zh -Duser.region=TW 
   CACHE STRING 
   "The arguments for running Sikuli IDE with 'make run'"
)
IF(APPLE)
   LIST(APPEND RUN_ARGS -Xdock:name='Sikuli IDE') 
ENDIF()

SET(ARGS "")

SET(CLASSPATH 
   ${SIKULI_SCRIPT_JAR}${SEP}${JUNIT_JAR}${SEP}${SWING_LAYOUT_JAR}${SEP}${COMMONS_CLI_JAR}${SEP}${JSON_SIMPLE_JAR}${SEP}${SWINGX_JAR}${SEP}${MAC_WIDGETS_JAR}${SEP}${FORMS_JAR}
)

SET(JAR_FILE sikuli-ide.jar)
SET(RESOURCES icons META-INF scripts i18n)

IF(LINUX)
   SET(MANIFEST ${RESOURCE_DIR}/META-INF/MANIFEST-linux.MF)
   SET(CLASSPATH ${CLASSPATH}${SEP}${JXGRABKEY_JAR})
ELSEIF(WIN32)
   SET(MANIFEST ${RESOURCE_DIR}/META-INF/MANIFEST-win32.MF)
   SET(CLASSPATH ${CLASSPATH}${SEP}${JINTELLITYPE_JAR})
ELSE()
   SET(MANIFEST ${RESOURCE_DIR}/META-INF/MANIFEST.MF)
ENDIF()


add_custom_target( ${JAR_FILE} 
   COMMAND ${JAVA_ARCHIVE} cfm ${BINARY_DIR}/${JAR_FILE}
           ${MANIFEST} -C ${JAR_DIR} *
   COMMAND ${CMAKE_COMMAND} -E copy ${BINARY_DIR}/${JAR_FILE} ${COMMON_LIB_DIR}/${JAR_FILE}
   COMMENT "Packaging ${JAR_FILE}"
   WORKING_DIRECTORY ${JAR_DIR}
)

add_custom_target( ${JAR_FILE}.resources
   COMMAND ${CMAKE_COMMAND} -E copy_directory ${RESOURCE_DIR} ${JAR_DIR}
   COMMENT "Copying IDE resources"
)

add_custom_target( ${JAR_FILE}.prepare
   COMMENT "Preparing ${JAR_FILE}"
)

add_custom_target( run-user
   COMMAND ${JAVA_RUNTIME} ${RUN_USER_ARGS} 
                        -classpath "${CLASSPATH}${SEP}${JAR_DIR}"
                        ${MAIN_CLASS} ${ARGS}
)

add_custom_target( run
   COMMAND ${JAVA_RUNTIME} ${RUN_ARGS} 
                        -classpath "${CLASSPATH}${SEP}${JAR_DIR}"
                        ${MAIN_CLASS} ${ARGS}
)

file(READ ${BASE_DIR}/latest-ver VERSION)
STRING(STRIP ${VERSION} VERSION)

add_custom_target( update-version
   COMMAND ${BASE_DIR}/../utils/update-version.sh  ${JAVA_SRC_DIR}/org/sikuli/ide/IDESettings.java "${VERSION}"
   COMMENT "Update version number in Sikuli-IDE"
)

SET(INCLUDE_JARS ${SIKULI_SCRIPT_JAR} ${JUNIT_JAR} 
                 ${SWING_LAYOUT_JAR} ${COMMONS_CLI_JAR}
                 ${BINARY_DIR}/${JAR_FILE} ${JSON_SIMPLE_JAR}
                 ${SWINGX_JAR} ${MAC_WIDGETS_JAR} ${FORMS_JAR}
)

## Windows Package

IF(WIN32)
   SET(OS "win32")
   SET(APP_FILE "Sikuli-IDE")
   SET(BINARY_APP_DIR  "${BINARY_DIR}/${OS}")
   SET(JAR_IN_APP_DIR  ${BINARY_APP_DIR}/${APP_FILE})
   SET(FRAMEWORKS_IN_APP_DIR  ${JAR_IN_APP_DIR}/libs)
   SET(JAR_LIB_DIR  ${JAR_DIR}/META-INF/lib)

   LIST(APPEND INCLUDE_JARS ${JINTELLITYPE_JAR})
   FILE(GLOB sikuli_script_jnilibs "${BASE_DIR}/../sikuli-script/target/lib/*.dll")
   SET(jnilibs ${sikuli_script_jnilibs})
ENDIF()

## Linux Package

IF(LINUX)
   SET(OS "linux")
   SET(APP_FILE "Sikuli-IDE")
   SET(BINARY_APP_DIR  "${BINARY_DIR}/${OS}")
   SET(JAR_IN_APP_DIR  ${BINARY_APP_DIR}/${APP_FILE})
   SET(FRAMEWORKS_IN_APP_DIR  ${JAR_IN_APP_DIR}/libs)
   SET(JAR_LIB_DIR  ${JAR_DIR}/META-INF/lib)

   LIST(APPEND INCLUDE_JARS ${JXGRABKEY_JAR})
   SET(jnilibs "")
   FILE(GLOB sikuli_script_jnilibs "${BASE_DIR}/../sikuli-script/target/lib/*.so")
   LIST(APPEND jnilibs ${sikuli_script_jnilibs})
ENDIF(LINUX)

## Sikuli-IDE.App for Mac OS X

IF(APPLE)
   IF(APPLE_SNOW_LEOPARD)
      SET(OSX_VER "osx-10.6")
   ELSEIF(APPLE_LEOPARD)
      SET(OSX_VER "osx-10.5")
   ENDIF()
   SET(OS ${OSX_VER})

   SET(APP_FILE  "Sikuli-IDE.app")
   SET(BINARY_APP_DIR  "${BINARY_DIR}/${OS}")
   SET(JAR_IN_APP_DIR  ${BINARY_APP_DIR}/${APP_FILE}/Contents/Resources/Java)
   SET(FRAMEWORKS_IN_APP_DIR  ${BINARY_APP_DIR}/${APP_FILE}/Contents/Frameworks)

   FIND_PACKAGE(OpenCV REQUIRED)
   #message("opencv lib: ${OpenCV_LIB_DIR}")
   LIST(APPEND CMAKE_LIBRARY_PATH ${OpenCV_LIB_DIR})

   FILE(GLOB jnilibs "${BINARY_LIB_DIR}/*.jnilib")
   FILE(GLOB sikuli_script_jnilibs "${BASE_DIR}/../sikuli-script/target/lib/*.jnilib")
   LIST(APPEND jnilibs ${sikuli_script_jnilibs})

   find_dep_libs("${jnilibs}" deplibs)
   find_dep_libs("${deplibs}" deplibs)
   LIST(REMOVE_ITEM deplibs "/usr/lib/libstdc++.6.dylib" "/usr/lib/libSystem.B.dylib" 
                            "/usr/lib/system/libmathCommon.A.dylib" 
                            "/usr/lib/libbz2.1.0.dylib" "/usr/lib/libobjc.A.dylib")
   #MESSAGE("Dep: ${deplibs}")

ENDIF(APPLE)

SET(RELEASE_FILE "Sikuli-${VERSION}-${OS}")

## Packaging App
add_custom_target( ${APP_FILE}
   COMMENT "Generate ${BINARY_DIR}/${APP_FILE}"
)

add_dependencies( ${APP_FILE} ${JAR_FILE} )

IF(LINUX)
   EXEC_PROGRAM(uname ARGS -m OUTPUT_VARIABLE SYSTEM_ARCH)
   if(SYSTEM_ARCH MATCHES "x86_64")
      SET(LIB_GRABKEY "${COMMON_LIB_DIR}/jxgrabkey/lib/libJXGrabKey-64.so")
   else()
      SET(LIB_GRABKEY "${COMMON_LIB_DIR}/jxgrabkey/lib/libJXGrabKey-32.so")
   endif()
   add_custom_target( ${JAR_FILE}.framework 
      COMMAND ${CMAKE_COMMAND} -E make_directory ${JAR_LIB_DIR}
      COMMAND cp ${LIB_GRABKEY} ${JAR_LIB_DIR}/libJXGrabKey.so
      COMMENT "Packaging Frameworks in Jar"
   )
   add_dependencies( ${JAR_FILE} ${JAR_FILE}.framework ) 

   add_custom_target( ${APP_FILE}.framework 
      COMMAND ${CMAKE_COMMAND} -E make_directory ${FRAMEWORKS_IN_APP_DIR}
      COMMAND cp ${jnilibs} ${FRAMEWORKS_IN_APP_DIR}
      COMMAND cp ${LIB_GRABKEY} ${FRAMEWORKS_IN_APP_DIR}/libJXGrabKey.so
      COMMENT "Packaging Frameworks in App"
   )
   add_dependencies( ${APP_FILE} ${APP_FILE}.framework ) 

ENDIF(LINUX)

IF(WIN32)
   SET(APP_FILES Sikuli-IDE-w.bat Sikuli-IDE.bat Sikuli-IDE.exe ide-icon.ico)
   SET(WIN32_LIBS ${COMMON_LIB_DIR}/win32)
   SET(OPENCV_LIBS cv210 cvaux210 cxcore210 highgui210 ml210)

   SET(LIB_GRABKEY "${COMMON_LIB_DIR}/jintellitype-1.3.6/JIntellitype.dll")
   add_custom_target( ${JAR_FILE}.framework 
      COMMAND ${CMAKE_COMMAND} -E make_directory ${JAR_LIB_DIR}
      COMMAND ${CMAKE_COMMAND} -E copy ${LIB_GRABKEY} ${JAR_LIB_DIR}/
      COMMENT "Packaging Frameworks in Jar"
   )
   add_dependencies( ${JAR_FILE} ${JAR_FILE}.framework ) 

   add_custom_target( ${APP_FILE}.framework 
      COMMAND ${CMAKE_COMMAND} -E make_directory ${FRAMEWORKS_IN_APP_DIR}
      COMMAND ${CMAKE_COMMAND} -E copy_directory ${WIN32_LIBS} ${FRAMEWORKS_IN_APP_DIR}
      COMMENT "Packaging Frameworks in App"
   )
   add_dependencies( ${APP_FILE} ${APP_FILE}.framework ) 

   #libs

   install(FILES ${jnilibs}
           DESTINATION ${FRAMEWORKS_IN_APP_DIR})
   FOREACH(F ${OPENCV_LIBS})
      install(FILES ${OpenCV_DIR}/bin/${F}.dll
              DESTINATION ${FRAMEWORKS_IN_APP_DIR})
   ENDFOREACH()

   FOREACH(F ${APP_FILES})
      install(FILES ${BINARY_APP_DIR}/${F}
              DESTINATION ${JAR_IN_APP_DIR})

   ENDFOREACH()
ENDIF(WIN32)

IF(APPLE)
   add_custom_target( ${APP_FILE}.framework 
      COMMAND ${CMAKE_COMMAND} -E make_directory ${FRAMEWORKS_IN_APP_DIR}
      COMMAND cp ${jnilibs} ${FRAMEWORKS_IN_APP_DIR}
      COMMAND cp ${deplibs} ${FRAMEWORKS_IN_APP_DIR}
      COMMAND ${CMAKE_COMMAND} -E chdir ${FRAMEWORKS_IN_APP_DIR} ./change-lib-path.sh
      COMMENT "Packaging Frameworks"
   )

   add_custom_target( ${APP_FILE}.update_ver
	COMMAND defaults write ${BINARY_APP_DIR}/${APP_FILE}/Contents/Info CFBundleVersion ${VERSION}
	COMMAND plutil -convert xml1 ${BINARY_APP_DIR}/${APP_FILE}/Contents/Info.plist
   )

   add_dependencies( ${APP_FILE} ${APP_FILE}.framework ${APP_FILE}.update_ver)

ENDIF(APPLE)

install(DIRECTORY ${BINARY_APP_DIR}/${APP_FILE}
   USE_SOURCE_PERMISSIONS
   DESTINATION .
)


add_custom_target( app ALL
)


FOREACH(JAR ${INCLUDE_JARS})
   get_filename_component(JAR_FILENAME ${JAR} NAME)
   get_filename_component(target ${JAR} NAME_WE)
   set(target "include_${target}")
   add_custom_target( ${target}
      COMMAND ${CMAKE_COMMAND} -E copy ${JAR} ${JAR_IN_APP_DIR}/${JAR_FILENAME}
                  
      COMMENT "Copying ${JAR_FILENAME}"
   )
   add_dependencies( ${APP_FILE} ${target} )
ENDFOREACH(JAR ${INCLUDE_JARS})


add_dependencies( app ${APP_FILE})

## Language files

add_custom_target( update-po
   COMMAND prop2po ${RESOURCE_DIR}/i18n/IDE_en_US.properties > ${RESOURCE_DIR}/i18n/IDE/IDE.pot
               
   COMMENT "Update the IDE.pot file"
)

add_custom_target( update-prop
   COMMAND ${BASE_DIR}/../utils/update-prop.sh ${RESOURCE_DIR}
   COMMENT "Update the IDE language properties."
)


## Packaging

if(APPLE)
   #   SET(CPACK_GENERATOR DragNDrop )
      SET(CPACK_GENERATOR ZIP )
else(APPLE)
   SET(CPACK_GENERATOR 
      ZIP
   )
endif(APPLE)

SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Sikuli ${VERSION}")
SET(CPACK_PACKAGE_VENDOR "Sikuli Development Team")
SET(CPACK_PACKAGE_DESCRIPTION_FILE "${BASE_DIR}/../readme.txt")
SET(CPACK_RESOURCE_FILE_LICENSE "${BASE_DIR}/../copyright.txt")
SET(CPACK_PACKAGE_FILE_NAME ${RELEASE_FILE})

INCLUDE(CPack)

install(FILES 
   ${CPACK_PACKAGE_DESCRIPTION_FILE}
   ${CPACK_RESOURCE_FILE_LICENSE}
   DESTINATION .
)

# type "make package" to generate release packages

## Dependencies

add_dependencies( ${JAR_FILE}.prepare
        ${JAR_FILE}.resources
        ${JAR_FILE}.classes-in-jar 
        ${JAR_FILE}.libs-in-jar
)

add_dependencies( ${JAR_FILE} ${JAR_FILE}.prepare )
add_dependencies( run-user ${JAR_FILE})
add_dependencies( run ${JAR_FILE})
add_dependencies( app ${APP_FILE}) 

ADD_SUBDIRECTORY( ${JAVA_SRC_DIR} )
ADD_SUBDIRECTORY( ${NATIVE_SRC_DIR} )

INCLUDE(CTest)

=== sikuli-script/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
PROJECT (sikuli-script Java)

ENABLE_TESTING()

SET(CMAKE_VERBOSE_MAKEFILE 0)
SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../cmake_modules/")
INCLUDE("${CMAKE_MODULE_PATH}/common.cmake")

FIND_PACKAGE(Java)
SET( NON_NATIVE_TARGET TRUE)

IF(UNIX)
   SET(SEP ":")
ELSE()
   SET(SEP ";")
ENDIF()

SET(NATIVE_PACKAGE org.sikuli.script.natives)
STRING(REPLACE . / NATIVE_PACKAGE_DIR ${NATIVE_PACKAGE})

SET(PACKAGE org.sikuli.script)
STRING(REPLACE . / PACKAGE_DIR ${PACKAGE})

SET(BASE_DIR "${CMAKE_CURRENT_SOURCE_DIR}")
SET(DOC_DIR "${BASE_DIR}/doc")
SET(JAVA_SRC_DIR "${BASE_DIR}/src/main/java")
SET(NATIVE_SRC_DIR "${BASE_DIR}/src/main/native")
SET(PYTHON_SRC_DIR "${BASE_DIR}/src/main/python")
SET(CMAKE_SWIG_OUTDIR ${CMAKE_BINARY_DIR}/${NATIVE_PACKAGE_DIR})

SET(COMMON_LIB_DIR "${BASE_DIR}/../lib")
#SET(INCLUDE_LIB_DIR "${BASE_DIR}/lib")
SET(INCLUDE_LIB_DIR "${COMMON_LIB_DIR}/mx-native-loader-1.2/target/classes")
SET(BINARY_DIR "${BASE_DIR}/target")
SET(BINARY_CLASS_DIR "${BINARY_DIR}/classes")
SET(BINARY_LIB_DIR "${BINARY_DIR}/lib")
SET(JAR_DIR "${BINARY_DIR}/jar")

SET(JYTHON_JAR "${COMMON_LIB_DIR}/jython-2.5.1.jar")
SET(JYTHON_LIB_FILE "${COMMON_LIB_DIR}/jython-lib-2.5.1.tgz")

SET(CLASSPATH 
   ${INCLUDE_LIB_DIR}${SEP}${JYTHON_JAR}${SEP}.
)

FILE(MAKE_DIRECTORY ${BINARY_DIR})
FILE(MAKE_DIRECTORY ${BINARY_CLASS_DIR})
FILE(MAKE_DIRECTORY ${JAR_DIR})

SET(JAR_FILE sikuli-script.jar)

add_custom_target( ${JAR_FILE} ALL
   COMMAND ${JAVA_ARCHIVE} cfm ${BINARY_DIR}/${JAR_FILE}
           ${BINARY_DIR}/MANIFEST.txt -C ${JAR_DIR} *
   COMMAND ${CMAKE_COMMAND} -E copy ${BINARY_DIR}/${JAR_FILE} ${COMMON_LIB_DIR}/${JAR_FILE}
   COMMENT "Preparing and packaging ${JAR_FILE}"
   WORKING_DIRECTORY ${JAR_DIR}
)

add_custom_target( ${JAR_FILE}.includes-in-jar 
   COMMAND ${CMAKE_COMMAND} -E copy_directory ${INCLUDE_LIB_DIR} ${JAR_DIR}
)

IF(NOT EXISTS ${JAR_DIR}/org/python)
   add_custom_target( ${JAR_FILE}.jython-in-jar
      COMMAND ${CMAKE_COMMAND} -E chdir ${JAR_DIR} ${JAVA_ARCHIVE} xf ${JYTHON_JAR}
      COMMENT "Merging Jython's JAR"
   )
ENDIF()

SET(LIB_IN_JAR_DIR "${JAR_DIR}/Lib")
add_custom_target( ${JAR_FILE}.python-src-in-jar
   COMMAND ${CMAKE_COMMAND} -E make_directory ${LIB_IN_JAR_DIR}
   COMMAND ${CMAKE_COMMAND} -E copy_directory ${PYTHON_SRC_DIR} ${LIB_IN_JAR_DIR}
   COMMENT "Copying Sikuli's Python Source"
)

IF(NOT EXISTS ${LIB_IN_JAR_DIR}/glob.py)
   add_custom_target( ${JAR_FILE}.jython-libs-in-jar
      COMMAND ${CMAKE_COMMAND} -E make_directory ${LIB_IN_JAR_DIR}
      COMMAND ${CMAKE_COMMAND} -E chdir ${LIB_IN_JAR_DIR} 
              ${CMAKE_COMMAND} -E tar xzf ${JYTHON_LIB_FILE}
      COMMENT "Copying Jython Libraries"
   )
ENDIF()

SET(TESSDATA_IN_JAR_DIR "${JAR_DIR}/tessdata")
SET(TESSDATA_LIST_TXT "${BINARY_DIR}/tessdata-list.txt")
IF(NOT EXISTS ${TESSDATA_IN_JAR_DIR}/filelist.txt)
   add_custom_target( ${JAR_FILE}.tessdata-in-jar
      COMMAND ${CMAKE_COMMAND} -E make_directory ${TESSDATA_IN_JAR_DIR}
      COMMAND ${CMAKE_COMMAND} -E copy_directory ${TESSERACT_DATA_DIR} ${TESSDATA_IN_JAR_DIR}
      COMMAND ${CMAKE_COMMAND} -E copy_if_different ${TESSDATA_LIST_TXT} ${TESSDATA_IN_JAR_DIR}/filelist.txt
      #      COMMAND cd ${TESSDATA_IN_JAR_DIR} && (find . -type f > filelist.txt)
      COMMENT "Copying Tesseract Data"
   )
ENDIF()

add_custom_target(doc
   javadoc -windowtitle "Javadoc of Sikuli Script" -sourcepath ${JAVA_SRC_DIR}
    -d ${DOC_DIR} -classpath ${CLASSPATH}  ${PACKAGE}
)

SET(RUN_SCRIPT_ARGS 
   "-i"
   CACHE STRING 
   "The arguments for running Sikuli Script with 'make run-script'")
add_custom_target(run-script
   java -jar ${BINARY_DIR}/${JAR_FILE} ${RUN_SCRIPT_ARGS}
)

file(READ ${BASE_DIR}/../sikuli-ide/latest-ver VERSION)
STRING(STRIP ${VERSION} VERSION)

add_custom_target( update-version
      COMMAND ${BASE_DIR}/../utils/update-version.sh  ${JAVA_SRC_DIR}/org/sikuli/script/Env.java "${VERSION}"
      COMMENT "Update version number to ${VERSION}"
)

# Dependencies

add_dependencies(${JAR_FILE} 
        ${JAR_FILE}.classes-in-jar 
        ${JAR_FILE}.python-src-in-jar
        ${JAR_FILE}.tessdata-in-jar
        ${JAR_FILE}.libs-in-jar
        ${JAR_FILE}.includes-in-jar
        ${JAR_FILE}.jython-in-jar
        ${JAR_FILE}.jython-libs-in-jar
)


ADD_SUBDIRECTORY(${NATIVE_SRC_DIR})
ADD_SUBDIRECTORY(${JAVA_SRC_DIR})

# Tests

SET(PYTHON_TESTS
   basic bundle capture click dragdrop env findAll 
   keys mouse multiscreen observe region 
   showActions sikuli type vdict wait with
   ocr imageurl wheel imagepath findfailed
)

SET(PY_TEST_DIR "${BASE_DIR}/src/test/python")
SET(JYTHON_CLASS org.python.util.jython)

FOREACH(TEST_TARGET ${PYTHON_TESTS})
   ADD_TEST(Jar_${TEST_TARGET} ${CMAKE_COMMAND} -E chdir ${BASE_DIR} 
                  java -Dsikuli.Debug=3 -cp ${BINARY_DIR}/${JAR_FILE} 
                  -Dpython.home=${BINARY_DIR}/${JAR_FILE} 
                  ${JYTHON_CLASS} ${PY_TEST_DIR}/test-${TEST_TARGET}.py
   )
ENDFOREACH(TEST_TARGET)

INCLUDE(CTest)

=== extensions/guide/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
PROJECT (guide Java)
SET(VERSION 1.4)

SET(PYTHON_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/main/python)
SET(JAVA_SOURCE_FILES    src/main/java/org/sikuli/guide/*.java)

SET(JAR_FILE ${PROJECT_NAME}-${VERSION}.jar)
SET(JAR_DIR ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-${VERSION}-jar)
SET(BINARY_CLASS_DIR ${CMAKE_CURRENT_BINARY_DIR}/classes)
FILE(MAKE_DIRECTORY ${BINARY_CLASS_DIR})

add_custom_target( ${PROJECT_NAME}.classes
    COMMAND ${JAVA_COMPILE} -d ${BINARY_CLASS_DIR} -classpath "${CLASSPATH}"
            ${JAVA_SOURCE_FILES}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})


add_custom_target( ${JAR_FILE}.classes-in-jar
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${BINARY_CLASS_DIR} ${JAR_DIR}
)

add_custom_target( ${JAR_FILE}.py-in-jar
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${PYTHON_SOURCE_DIR} ${JAR_DIR}
)
                                                                                

add_custom_target( ${JAR_FILE} ALL
   COMMAND ${JAVA_ARCHIVE} cf ${CMAKE_BINARY_DIR}/${JAR_FILE}
           -C ${JAR_DIR} *
   COMMENT "Preparing and packaging ${JAR_FILE}"
   WORKING_DIRECTORY ${JAR_DIR}
)

add_dependencies(${JAR_FILE} ${JAR_FILE}.classes-in-jar ${JAR_FILE}.py-in-jar)
add_dependencies(${JAR_FILE}.classes-in-jar ${PROJECT_NAME}.classes)

=== sikuli-ide/src/main/java/CMakeLists.txt ===
IF(APPLE)
   SET(OS_EXTRA_SOURCE_FILES org/sikuli/ide/NativeLayerForMac.java)
ELSEIF(LINUX)
   SET(OS_EXTRA_SOURCE_FILES org/sikuli/ide/NativeLayerForLinux.java)
ELSEIF(WIN32)
   SET(OS_EXTRA_SOURCE_FILES org/sikuli/ide/NativeLayerForWindows.java)
ENDIF()

SET(JAVA_SOURCE_FILES 
         ${OS_EXTRA_SOURCE_FILES}
         org/sikuli/ide/AutoUpdater.java
         org/sikuli/ide/ButtonGenCommand.java
         org/sikuli/ide/CaptureButton.java
         org/sikuli/ide/CloseableTabbedPane.java
         org/sikuli/ide/CloseableTabbedPaneListener.java
         org/sikuli/ide/CommandArgs.java
         org/sikuli/ide/ConsolePane.java
         org/sikuli/ide/CurrentLineHighlighter.java
         org/sikuli/ide/FileChooser.java
         org/sikuli/ide/I18N.java
         org/sikuli/ide/IDESettings.java
         org/sikuli/ide/ImageButton.java
         org/sikuli/ide/LineNumberView.java
         org/sikuli/ide/MyDocument.java
         org/sikuli/ide/NativeLayer.java
         org/sikuli/ide/Observer.java
         org/sikuli/ide/PatternWindow.java
         org/sikuli/ide/PreferencesWin.java
         org/sikuli/ide/RegionButton.java
         org/sikuli/ide/ScreenshotPane.java
         org/sikuli/ide/sikuli_test/CounterPanel.java
         org/sikuli/ide/sikuli_test/DefaultFailureDetailView.java
         org/sikuli/ide/sikuli_test/FailureRunView.java
         org/sikuli/ide/sikuli_test/ProgressBar.java
         org/sikuli/ide/sikuli_test/TestHierarchyRunView.java
         org/sikuli/ide/sikuli_test/TestRunContext.java
         org/sikuli/ide/sikuli_test/TestRunView.java
         org/sikuli/ide/sikuli_test/TestSuitePanel.java
         org/sikuli/ide/sikuli_test/TestTreeModel.java
         org/sikuli/ide/sikuli_test/TextUnitTestRunner.java
         org/sikuli/ide/sikuli_test/UnitTestRunner.java
         org/sikuli/ide/SikuliDocument.java
         org/sikuli/ide/SikuliEditorKit.java
         org/sikuli/ide/SikuliIDE.java
         org/sikuli/ide/SikuliPane.java
         org/sikuli/ide/SikuliView.java
         org/sikuli/ide/SikuliViewFactory.java
         org/sikuli/ide/SimilaritySlider.java
         org/sikuli/ide/StatusBar.java
         org/sikuli/ide/Subject.java
         org/sikuli/ide/TargetOffsetPane.java
         org/sikuli/ide/ToolbarButton.java
         org/sikuli/ide/UserPreferences.java
         org/sikuli/ide/Utils.java
         org/sikuli/ide/NamingPane.java
         org/sikuli/ide/ModernTabbedPaneUI.java
         org/sikuli/ide/UndoManager.java
         org/sikuli/ide/BevelDividerPainter.java
         org/sikuli/ide/extmanager/ExtensionItem.java
         org/sikuli/ide/extmanager/ExtensionManagerFrame.java
)

add_custom_target( ${PROJECT_NAME}.classes
    COMMAND ${JAVA_COMPILE} -d ${BINARY_CLASS_DIR} -classpath "${CLASSPATH}"
            ${JAVA_SOURCE_FILES}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
     

add_custom_target( ${JAR_FILE}.classes-in-jar
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${BINARY_CLASS_DIR} ${JAR_DIR}
)

add_dependencies(${JAR_FILE}.classes-in-jar ${PROJECT_NAME}.classes)

=== sikuli-ide/src/main/native/CMakeLists.txt ===
ENABLE_LANGUAGE(CXX)

SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../../../../cmake_modules/")
INCLUDE("${CMAKE_MODULE_PATH}/common.cmake")

FIND_PROGRAM ( JAVA_JAVA_H javah PATHS ${JAVA_BIN_PATH} )
SET(JNI_HEADERS
   org_sikuli_ide_NativeLayerForMac.h
)

SET(LIBRARY_OUTPUT_PATH ${BINARY_LIB_DIR})

FIND_PACKAGE(JNI REQUIRED)
IF(APPLE)
   FIND_LIBRARY(CARBON_LIBRARY Carbon)
   FIND_LIBRARY(COREFOUNDATION_LIBRARY CoreFoundation)
   SET(EXTRA_LIBS ${CARBON_LIBRARY} ${COREFOUNDATION_LIBRARY})
ENDIF(APPLE)

INCLUDE_DIRECTORIES(${JNI_INCLUDE_DIRS})


IF(APPLE)
   SET(BUILD_TARGETS
      NativeLayerForMac
   )

   ADD_LIBRARY(NativeLayerForMac SHARED
      NativeLayerForMac.cc
      org_sikuli_ide_NativeLayerForMac.h
   )

ENDIF(APPLE)

foreach(JNI_HEADER ${JNI_HEADERS})
   STRING(REGEX REPLACE "_" "." JNI_CLASS ${JNI_HEADER})
   STRING(REGEX REPLACE "\\.h$" "" JNI_CLASS ${JNI_CLASS})
   STRING(REGEX REPLACE "\\." "/" JNI_JAVA_SOURCE ${JNI_CLASS})
   SET(JNI_JAVA_SOURCE "${JNI_JAVA_SOURCE}.java")
   ADD_CUSTOM_COMMAND(
      OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/${JNI_HEADER}
      COMMAND ${JAVA_JAVA_H} -d ${CMAKE_CURRENT_SOURCE_DIR} 
                             -classpath ${BINARY_CLASS_DIR} ${JNI_CLASS}
      DEPENDS ${JAVA_SRC_DIR}/${JNI_JAVA_SOURCE}
   )
endforeach(JNI_HEADER ${JNI_HEADERS})


foreach(BUILD_TARGET ${BUILD_TARGETS})
   TARGET_LINK_LIBRARIES(${BUILD_TARGET} ${EXTRA_LIBS})
   if(APPLE)
      set_target_properties(${BUILD_TARGET} PROPERTIES SUFFIX ".jnilib")
   endif(APPLE)
endforeach(BUILD_TARGET ${BUILD_TARGETS})

add_custom_target(${JAR_FILE}.libs-in-jar
   COMMAND ${CMAKE_COMMAND} -E make_directory ${JAR_DIR}/META-INF
   COMMAND ${CMAKE_COMMAND} -E copy_directory ${BINARY_LIB_DIR} ${JAR_DIR}/META-INF/lib
)

IF(EXISTS ${BUILD_TARGETS})
   add_dependencies(${JAR_FILE}.libs-in-jar ${BUILD_TARGETS})
ENDIF()

=== sikuli-script/src/main/java/CMakeLists.txt ===
IF(APPLE)
   SET(OS_EXTRA_SOURCE_FILES org/sikuli/script/MacUtil.java)
ELSEIF(LINUX)
   SET(OS_EXTRA_SOURCE_FILES org/sikuli/script/LinuxUtil.java)
ELSEIF(WIN32)
   SET(OS_EXTRA_SOURCE_FILES org/sikuli/script/Win32Util.java)
ENDIF()


SET(JAVA_SOURCE_FILES 
   ${CMAKE_SWIG_OUTDIR}/*.java
   ${OS_EXTRA_SOURCE_FILES}
   org/sikuli/script/AppearEvent.java
   org/sikuli/script/CapturePrompt.java
   org/sikuli/script/ChangeEvent.java
   org/sikuli/script/Clipboard.java
   org/sikuli/script/Debug.java
   org/sikuli/script/DummyOSUtil.java
   org/sikuli/script/Env.java
   org/sikuli/script/EventManager.java
   org/sikuli/script/FindFailed.java
   org/sikuli/script/Finder.java
   org/sikuli/script/KeyCodeConverter.java
   org/sikuli/script/Location.java
   org/sikuli/script/Match.java
   org/sikuli/script/OS.java
   org/sikuli/script/OSUtil.java
   org/sikuli/script/Observer.java
   org/sikuli/script/OpenCV.java
   org/sikuli/script/ScreenHighlighter.java
   org/sikuli/script/Pattern.java
   org/sikuli/script/Region.java
   org/sikuli/script/Screen.java
   org/sikuli/script/ScreenImage.java
   org/sikuli/script/ScriptRunner.java
   org/sikuli/script/Settings.java
   org/sikuli/script/SikuliEvent.java
   org/sikuli/script/SikuliEventAdapter.java
   org/sikuli/script/SikuliEventObserver.java
   org/sikuli/script/SikuliScript.java
   org/sikuli/script/Subject.java
   org/sikuli/script/UnionScreen.java
   org/sikuli/script/VDictProxy.java
   org/sikuli/script/VanishEvent.java
   org/sikuli/script/App.java
   org/sikuli/script/ImageLocator.java
   org/sikuli/script/ResourceExtractor.java
   org/sikuli/script/SikuliException.java
   org/sikuli/script/AppNotFound.java
   org/sikuli/script/Animator.java
   org/sikuli/script/TransparentWindow.java
   org/sikuli/script/ExtensionManager.java
)

add_custom_target( ${PROJECT_NAME}.classes
    COMMAND ${JAVA_COMPILE} -d ${BINARY_CLASS_DIR} -classpath "${CLASSPATH}"
            ${JAVA_SOURCE_FILES}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
     

add_custom_target( ${JAR_FILE}.classes-in-jar
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${BINARY_CLASS_DIR} ${JAR_DIR}
)

add_dependencies(${JAR_FILE}.classes-in-jar ${PROJECT_NAME}.classes)
add_dependencies(${PROJECT_NAME}.classes VisionProxy)

=== sikuli-script/src/main/native/CMakeLists.txt ===
ENABLE_LANGUAGE(CXX)

IF(LINUX)
   # -O2/O3 seems incorrectly optimizes some SWIG generated code
   SET(CMAKE_CXX_FLAGS_RELEASE "-O1")
ENDIF(LINUX)

SET(CMAKE_VERBOSE_MAKEFILE 1)

SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../../../../cmake_modules/")
INCLUDE("${CMAKE_MODULE_PATH}/common.cmake")


FIND_PROGRAM ( JAVA_JAVA_H javah PATHS ${JAVA_BIN_PATH} )
SET(JNI_HEADERS
   org_sikuli_script_VDictProxy.h
   org_sikuli_script_Win32Util.h
   org_sikuli_script_MacUtil.h
)

SET(LIBRARY_OUTPUT_PATH ${BINARY_LIB_DIR})

FIND_PACKAGE(OpenCV REQUIRED)
FIND_PACKAGE(JNI REQUIRED)
FIND_PACKAGE(SWIG REQUIRED)

INCLUDE_DIRECTORIES(${JNI_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${OPENCV_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})
INCLUDE(${SWIG_USE_FILE})

# profiling
#LIST(APPEND CMAKE_CXX_FLAGS "-DENABLE_TIMING")
# visual logger for debugging
#LIST(APPEND CMAKE_CXX_FLAGS "-DENABLE_VISUAL_LOG")
# OCR matching debug
#LIST(APPEND CMAKE_CXX_FLAGS "-DENABLE_OCR_DEBUG")

IF(NOT WIN32)
   FIND_PACKAGE(Tesseract REQUIRED)
   INCLUDE_DIRECTORIES(${Tesseract_INCLUDE_DIR})
ELSE()
   SET(TESSERACT_SRC_DIRS ccmain ccutil ccstruct viewer 
                          image textord wordrec dict cutil
                          classify aspirin dict display pageseg)
   FOREACH(DIR ${TESSERACT_SRC_DIRS})
      FILE(GLOB T_SRCS 
         ${TESSERACT_SRC_DIR}/${DIR}/*.cpp
      )
      SET(TESSERACT_SOURCES ${TESSERACT_SOURCES} ${T_SRCS})
      INCLUDE_DIRECTORIES(${TESSERACT_SRC_DIR}/${DIR})
   ENDFOREACH()
   LIST(REMOVE_ITEM TESSERACT_SOURCES ${TESSERACT_SRC_DIR}/ccmain/tessembedded.cpp)
   LIST(REMOVE_ITEM TESSERACT_SOURCES ${TESSERACT_SRC_DIR}/ccutil/scanutils.cpp)
   LIST(REMOVE_ITEM TESSERACT_SOURCES ${TESSERACT_SRC_DIR}/viewer/svpaint.cpp)

   INCLUDE_DIRECTORIES($ENV{INCLUDE})
   LINK_DIRECTORIES($ENV{LIB})
   SET(Tesseract_INCLUDE_DIR "")
   SET(Tesseract_LIBRARY user32 ws2_32)
   SET(CMAKE_CXX_FLAGS "/D__MSW32__ /DWIN32 /D_WINDOWS /D_CRT_SECURE_NO_WARNINGS")
ENDIF()


LINK_DIRECTORIES(${OpenCV_LIBRARY_DIR})

# tom SET(CMAKE_SWIG_FLAGS -package ${PACKAGE})
SET(CMAKE_SWIG_FLAGS -package ${NATIVE_PACKAGE})
SET(SWIG_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})

IF(LINUX)
   FIND_LIBRARY(TIFF_LIBS NAMES tiff)
   LIST(APPEND OpenCV_LIBS ${TIFF_LIBS})
ENDIF()

SET(BUILD_TARGETS
   #TODO move VDictProxy to swig
   VDictProxy
)

IF(WIN32)
   LIST(APPEND BUILD_TARGETS Win32Util)

   ADD_LIBRARY(Win32Util SHARED
      Win32Util.cc
      org_sikuli_script_Win32Util.h
   )
   TARGET_LINK_LIBRARIES(Win32Util ${JAVA_AWT_LIBRARY})
ENDIF()

IF(APPLE)
   LIST(APPEND BUILD_TARGETS MacUtil)
   FIND_LIBRARY(JAVA_LIBRARY JavaVM)
   FIND_LIBRARY(COCOA_LIBRARY Cocoa)
   FIND_LIBRARY(CARBON_LIBRARY Carbon)
   FIND_LIBRARY(COREFOUNDATION_LIBRARY CoreFoundation)
   SET(EXTRA_LIBS ${JAVA_LIBRARY} ${COCOA_LIBRARY} ${CARBON_LIBRARY} ${COREFOUNDATION_LIBRARY})

   ADD_LIBRARY(MacUtil SHARED
      MacUtil.m
      org_sikuli_script_MacUtil.h
   )
   TARGET_LINK_LIBRARIES(MacUtil ${EXTRA_LIBS})
ENDIF()

SET(NATIVE_LIBS
   VisionProxy
   ${BUILD_TARGETS}
)

ADD_LIBRARY(VDictProxy SHARED
   VDictProxy.cc
   org_sikuli_script_VDictProxy.h
)


## SWIG: generate a JNI wrapper 
SET_SOURCE_FILES_PROPERTIES(vision.i PROPERTIES CPLUSPLUS ON)
SWIG_ADD_MODULE(VisionProxy java vision.i
   TimingBlock.cc
   cvgui.cpp
   finder.cpp
   imgdb.cpp
   pyramid-template-matcher.cpp
   tessocr.cpp
   vision.cpp
   sikuli-debug.cpp
   ${TESSERACT_SOURCES}
) 
SWIG_LINK_LIBRARIES(VisionProxy ${Tesseract_LIBRARY} ${OpenCV_LIBS})  


#TODO: replace jni custom commands by swig
foreach(JNI_HEADER ${JNI_HEADERS})
   STRING(REGEX REPLACE "_" "." JNI_CLASS ${JNI_HEADER})
   STRING(REGEX REPLACE "\\.h$" "" JNI_CLASS ${JNI_CLASS})
   STRING(REGEX REPLACE "\\." "/" JNI_JAVA_SOURCE ${JNI_CLASS})
   SET(JNI_JAVA_CLASS "${JNI_JAVA_SOURCE}.class")
   SET(JNI_JAVA_SOURCE "${JNI_JAVA_SOURCE}.java")
   ADD_CUSTOM_COMMAND(
      OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/${JNI_HEADER}
      COMMAND ${JAVA_JAVA_H} -d ${CMAKE_CURRENT_SOURCE_DIR} 
                             -classpath ${BINARY_CLASS_DIR} ${JNI_CLASS}
      DEPENDS ${JAVA_SRC_DIR}/${JNI_JAVA_SOURCE}
   )
endforeach(JNI_HEADER ${JNI_HEADERS})


foreach(BUILD_TARGET ${BUILD_TARGETS})
   TARGET_LINK_LIBRARIES(${BUILD_TARGET} ${OpenCV_LIBS})
   if(APPLE)
      set_target_properties(${BUILD_TARGET} PROPERTIES SUFFIX ".jnilib")
   endif(APPLE)
endforeach(BUILD_TARGET ${BUILD_TARGETS})

add_custom_target(${JAR_FILE}.libs-in-jar
   COMMAND ${CMAKE_COMMAND} -E make_directory ${JAR_DIR}/META-INF
   COMMAND ${CMAKE_COMMAND} -E copy_directory ${BINARY_LIB_DIR} ${JAR_DIR}/META-INF/lib
)

add_dependencies(${JAR_FILE}.libs-in-jar ${NATIVE_LIBS})

## sikuli 1.0~x~rc2-dfsg1

=== debian/changelog ===
sikuli (1.0~x~rc2-dfsg1-2ubuntu1) oneiric; urgency=low

  * debian/rules: fix multiarch-related FTBFS.

 -- Ilya Barygin <barygin@gmail.com>  Sun, 14 Aug 2011 18:09:12 +0400

sikuli (1.0~x~rc2-dfsg1-2) unstable; urgency=low

  * debian/control, debian/copyright:
    + Fix pkg-java-maintainers address. 
  * debian/copyright:
    + Update to DEP5 format specification rev174

 -- Gilles Filippini <pini@debian.org>  Sat, 16 Apr 2011 12:48:15 +0200

sikuli (1.0~x~rc2-dfsg1-1) unstable; urgency=low

  * New upstream release:
    + Redesigned user interface for Sikuli-IDE
    + Support for extensions for Sikuli Script

  * debian/control, debian/copyright:
    The package is now maintained by the Debian Java maintainers Team

 -- Gilles Filippini <pini@debian.org>  Sat, 16 Apr 2011 00:23:53 +0200

sikuli (1.0~x~rc1-dfsg1-2) unstable; urgency=low

  * debian/control: enforce java6 dependency using a versioned [Build-]Depends
    against default-jdk and default-jre (>= 1:1.6) instead of depending on
    java6-sdk and java6-runtime. 

 -- Gilles Filippini <pini@debian.org>  Mon, 24 Jan 2011 01:07:30 +0100

sikuli (1.0~x~rc1-dfsg1-1) unstable; urgency=low

  * Initial release (Closes: #578125)

 -- Gilles Filippini <pini@debian.org>  Thu, 20 Jan 2011 22:37:52 +0100

=== debian/control ===
Source: sikuli
Section: java
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Java maintainers <pkg-java-maintainers@lists.alioth.debian.org>
Uploaders: Gilles Filippini <pini@debian.org>
Build-Depends: debhelper (>= 7.0.50~), javahelper, default-jdk (>= 1:1.6), cmake, jython, libcv-dev, libcvaux-dev, libhighgui-dev, libcommons-cli-java, junit, libswing-layout-java, libswingx-java, libjxgrabkey-java, libjgoodies-forms-java, libjson-simple-java, libmac-widgets-java, zip, exuberant-ctags, tesseract-ocr-dev, swig,
 default-jdk-doc, jython-doc, junit-doc, libswing-layout-java-doc, libswingx-java-doc, libjxgrabkey-doc, libjgoodies-forms-java-doc, libjson-simple-doc, libmac-widgets-doc
Standards-Version: 3.9.1
Homepage: http://sikuli.org
Vcs-Git: git://git.debian.org/collab-maint/sikuli.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/sikuli.git;a=summary

Package: sikuli-ide
Architecture: all
Depends: ${java:Depends}, ${misc:Depends}, default-jre (>= 1:1.6) | java6-runtime, libsikuli-script-java, junit, libswingx-java
Description: IDE to develop sikuli scripts and use them a junit test cases
 Sikuli mixes image recognition into jython scripting to automate
 interactions with graphical user interfaces.
 .
 With Sikuli it is very easy to programmatically control a web page, a
 desktop application, or even an iphone application running in an emulator.
 .
 This package features Sikuli IDE, the integrated development environment
 for writing visual scripts with screenshots.
 .
 sikuli-ide also provides junit integration for running sikuli scripts as
 junit test cases.

Package: libsikuli-script-java
Architecture: all
Depends: ${java:Depends}, ${misc:Depends}, default-jre (>= 1:1.6) | java6-runtime, libsikuli-script-jni, jython
Suggests: libsikuli-script-doc
Description: Visual scripting API for jython
 Sikuli mixes image recognition into Jython scripting to automate
 interactions with graphical user interfaces.
 .
 With Sikuli it is very easy to programmatically control a web page, a
 desktop application, or even an iphone application running in an emulator.
 .
 This package features the jython sikuli visual scripting API and the sikuli
 script interpreter.

Package: libsikuli-script-jni
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Native libs for libsikuli-java
 Sikuli mixes image recognition into jython scripting to automate
 interactions with graphical user interfaces.
 .
 This package holds the architecture dependent jni backend of the java
 library.

Package: libsikuli-script-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: default-jdk-doc, jython-doc, junit-doc, libswing-layout-java-doc, libjxgrabkey-doc, libjson-simple-doc, libmac-widgets-doc
Description: Documentation for libsikuli-script-java
 Sikuli mixes image recognition into jython scripting to automate
 interactions with graphical user interfaces.
 .
 This package contains the javadoc API documentation for the java library
 libsikuli-script-java.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh --with javahelper $@ 

override_dh_auto_configure:
	# Time stamp to prevent re-generation
	touch ./sikuli-script/src/main/native/org_sikuli_script_VDictProxy.h

override_dh_auto_clean:
	rm -fr \
		sikuli-script/build \
		sikuli-script/target/*.jar \
		sikuli-script/target/classes \
		sikuli-script/target/lib \
		sikuli-script/target/jar \
		sikuli-script/doc \
		sikuli-ide/build \
		sikuli-ide/target/*.jar \
		sikuli-ide/target/classes \
		sikuli-ide/target/linux/Sikuli-IDE/*.jar \
		sikuli-ide/target/linux/Sikuli-IDE/classes \
		sikuli-ide/target/linux/Sikuli-IDE/libs \
		sikuli-ide/target/jar \
		lib
	dh_auto_clean

override_dh_auto_build:
	mkdir sikuli-script/build sikuli-ide/build
	cd sikuli-script/build && \
                cmake -D CMAKE_LIBRARY_ARCHITECTURE=$(DEB_HOST_MULTIARCH) ..
	make -C sikuli-script/build
	cd sikuli-ide/build && cmake ..
	make -C sikuli-ide/build app
	javadoc -windowtitle "Javadoc of Sikuli Script" -sourcepath sikuli-script/src/main/java:sikuli-script/build -d sikuli-script/doc/ -classpath lib:/usr/share/java/jython.jar \
		-link /usr/share/doc/default-jdk-doc/api \
		-link /usr/share/doc/jython-doc/api-html \
		-link /usr/share/doc/junit-doc/doc/api \
		-link /usr/share/doc/libswing-layout-java-doc/api \
		-link /usr/share/doc/libjxgrabkey-java/api \
		org.sikuli.script

override_jh_build:
	# no-op

override_dh_install:
	mkdir -p debian/libsikuli-script-java/usr/bin
	install sikuli-script/target/sikuli-script.sh debian/libsikuli-script-java/usr/bin/sikuli
	
	mkdir -p debian/sikuli-ide/usr/bin
	install sikuli-ide/target/linux/Sikuli-IDE/sikuli-ide.sh debian/sikuli-ide/usr/bin/sikuli-ide
	
	dh_install

## sikuli 1.0~x~rc3

=== sikuli-script/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,5 @@
+# Copyright 2010-2011, Sikuli.org
+# Released under the MIT License.
 cmake_minimum_required(VERSION 2.6)
 PROJECT (sikuli-script Java)
 
@@ -7,7 +9,7 @@
 SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../cmake_modules/")
 INCLUDE("${CMAKE_MODULE_PATH}/common.cmake")
 
-FIND_PACKAGE(Java)
+FIND_PACKAGE(Java 1.6 REQUIRED)
 SET( NON_NATIVE_TARGET TRUE)
 
 IF(UNIX)
@@ -27,25 +29,51 @@
 SET(JAVA_SRC_DIR "${BASE_DIR}/src/main/java")
 SET(NATIVE_SRC_DIR "${BASE_DIR}/src/main/native")
 SET(PYTHON_SRC_DIR "${BASE_DIR}/src/main/python")
+SET(JAVA_TEST_DIR "${BASE_DIR}/src/test/java")
+SET(TEST_RESOURCE_DIR "test-res")
+SET(JAVA_TEST_FOR_HUDSON_XML "../hudson-test.xml")
+
 SET(CMAKE_SWIG_OUTDIR ${CMAKE_BINARY_DIR}/${NATIVE_PACKAGE_DIR})
 
 SET(COMMON_LIB_DIR "${BASE_DIR}/../lib")
+
+# dependent libs
+SET(JXGRABKEY_JAR "${COMMON_LIB_DIR}/jxgrabkey/lib/JXGrabKey.jar")
+SET(JINTELLITYPE_JAR "${COMMON_LIB_DIR}/jintellitype-1.3.6/jintellitype-1.3.6.jar")
+
 #SET(INCLUDE_LIB_DIR "${BASE_DIR}/lib")
 SET(INCLUDE_LIB_DIR "${COMMON_LIB_DIR}/mx-native-loader-1.2/target/classes")
+
 SET(BINARY_DIR "${BASE_DIR}/target")
-SET(BINARY_CLASS_DIR "${BINARY_DIR}/classes")
+SET(BINARY_CLASS_DIR "${CMAKE_BINARY_DIR}/classes")
+SET(TEST_CLASS_DIR "${CMAKE_BINARY_DIR}/test")
 SET(BINARY_LIB_DIR "${BINARY_DIR}/lib")
-SET(JAR_DIR "${BINARY_DIR}/jar")
-
-SET(JYTHON_JAR "${COMMON_LIB_DIR}/jython-2.5.1.jar")
-SET(JYTHON_LIB_FILE "${COMMON_LIB_DIR}/jython-lib-2.5.1.tgz")
+SET(JAR_DIR "${CMAKE_BINARY_DIR}/jar")
+SET(JAR_LIB_DIR  ${JAR_DIR}/META-INF/lib)
+
+SET(JUNIT_JAR "${COMMON_LIB_DIR}/junit-4.8.2.jar")
+SET(MOCKITO_JAR "${COMMON_LIB_DIR}/mockito-all-1.8.5.jar")
+SET(JYTHON_JAR "${COMMON_LIB_DIR}/jython-2.5.2.jar")
+SET(JYTHON_LIB_FILE "${COMMON_LIB_DIR}/jython-lib-2.5.2.tgz")
 
 SET(CLASSPATH 
    ${INCLUDE_LIB_DIR}${SEP}${JYTHON_JAR}${SEP}.
 )
 
+IF(LINUX)
+   SET(CLASSPATH ${CLASSPATH}${SEP}${JXGRABKEY_JAR})
+ELSEIF(WIN32)
+   SET(CLASSPATH ${CLASSPATH}${SEP}${JINTELLITYPE_JAR})
+ENDIF()
+
+
+SET(TEST_CLASSPATH
+   ${CLASSPATH}${SEP}${JUNIT_JAR}${SEP}${BINARY_CLASS_DIR}${SEP}${MOCKITO_JAR}
+)
+
 FILE(MAKE_DIRECTORY ${BINARY_DIR})
 FILE(MAKE_DIRECTORY ${BINARY_CLASS_DIR})
+FILE(MAKE_DIRECTORY ${TEST_CLASS_DIR})
 FILE(MAKE_DIRECTORY ${JAR_DIR})
 
 SET(JAR_FILE sikuli-script.jar)
@@ -68,6 +96,7 @@
       COMMENT "Merging Jython's JAR"
    )
 ENDIF()
+
 
 SET(LIB_IN_JAR_DIR "${JAR_DIR}/Lib")
 add_custom_target( ${JAR_FILE}.python-src-in-jar
@@ -98,7 +127,7 @@
 ENDIF()
 
 add_custom_target(doc
-   javadoc -windowtitle "Javadoc of Sikuli Script" -sourcepath ${JAVA_SRC_DIR}
+   javadoc -public -docencoding utf-8 -windowtitle "Javadoc of Sikuli Script" -sourcepath ${JAVA_SRC_DIR}
     -d ${DOC_DIR} -classpath ${CLASSPATH}  ${PACKAGE}
 )
 
@@ -117,6 +146,13 @@
       COMMAND ${BASE_DIR}/../utils/update-version.sh  ${JAVA_SRC_DIR}/org/sikuli/script/Env.java "${VERSION}"
       COMMENT "Update version number to ${VERSION}"
 )
+
+add_custom_target(${JAR_FILE}.libs-in-jar
+   COMMAND ${CMAKE_COMMAND} -E make_directory ${JAR_DIR}/META-INF
+   COMMAND ${CMAKE_COMMAND} -E copy_directory ${BINARY_LIB_DIR} ${JAR_LIB_DIR}
+   COMMENT "Build native libs"
+)
+
 
 # Dependencies
 
@@ -130,28 +166,135 @@
         ${JAR_FILE}.jython-libs-in-jar
 )
 
-
+IF(WIN32)
+   IF(NOT EXISTS ${JAR_DIR}/com/melloware/jintellitype)
+      add_custom_target( ${JAR_FILE}.jintellitype-in-jar
+         COMMAND ${CMAKE_COMMAND} -E chdir ${JAR_DIR} ${JAVA_ARCHIVE} xf ${JINTELLITYPE_JAR}
+         COMMENT "Merging Jintellitype's JAR"
+      )
+      add_dependencies(${JAR_FILE} 
+         ${JAR_FILE}.jintellitype-in-jar
+      )
+
+      SET(LIB_GRABKEY "${COMMON_LIB_DIR}/jintellitype-1.3.6/JIntellitype.dll")
+      SET(LIB_GRABKEY64 "${COMMON_LIB_DIR}/jintellitype-1.3.6/JIntellitype64.dll")
+      add_custom_target( ${JAR_FILE}.hotkey-lib 
+         COMMAND ${CMAKE_COMMAND} -E copy ${LIB_GRABKEY} ${JAR_DIR}/com/melloware/jintellitype/
+         COMMAND ${CMAKE_COMMAND} -E copy ${LIB_GRABKEY64} ${JAR_DIR}/com/melloware/jintellitype/
+         COMMENT "Packaging JIntellitype in Jar"
+      )
+      add_dependencies( ${JAR_FILE}.hotkey-lib
+         ${JAR_FILE}.jintellitype-in-jar 
+      )
+   ENDIF(NOT EXISTS ${JAR_DIR}/com/melloware/jintellitype)
+
+ENDIF(WIN32)
+
+IF(LINUX)
+   IF(NOT EXISTS ${JAR_DIR}/jxgrabkey)
+      add_custom_target( ${JAR_FILE}.jxgrabkey-in-jar
+         COMMAND ${CMAKE_COMMAND} -E chdir ${JAR_DIR} ${JAVA_ARCHIVE} xf ${JXGRABKEY_JAR}
+         COMMENT "Merging JXGrabKey's JAR"
+      )
+   ENDIF()
+
+   add_dependencies(${JAR_FILE} 
+      ${JAR_FILE}.jxgrabkey-in-jar
+   )
+ENDIF(LINUX)
+
+IF(LINUX)
+   EXEC_PROGRAM(uname ARGS -m OUTPUT_VARIABLE SYSTEM_ARCH)
+   if(SYSTEM_ARCH MATCHES "x86_64")
+      SET(LIB_GRABKEY "${COMMON_LIB_DIR}/jxgrabkey/lib/libJXGrabKey-64.so")
+   else()
+      SET(LIB_GRABKEY "${COMMON_LIB_DIR}/jxgrabkey/lib/libJXGrabKey-32.so")
+   endif()
+   add_custom_target( ${JAR_FILE}.hotkey-lib 
+      COMMAND cp ${LIB_GRABKEY} ${BINARY_LIB_DIR}/libJXGrabKey.so
+      COMMENT "Packaging JXGrabKey in Jar"
+   )
+ENDIF(LINUX)
+add_dependencies( ${JAR_FILE} ${JAR_FILE}.hotkey-lib ) 
+add_dependencies( ${JAR_FILE}.libs-in-jar ${JAR_FILE}.hotkey-lib ) 
+
+
+ADD_SUBDIRECTORY(${JAVA_SRC_DIR})
 ADD_SUBDIRECTORY(${NATIVE_SRC_DIR})
-ADD_SUBDIRECTORY(${JAVA_SRC_DIR})
-
-# Tests
-
-SET(PYTHON_TESTS
-   basic bundle capture click dragdrop env findAll 
-   keys mouse multiscreen observe region 
-   showActions sikuli type vdict wait with
-   ocr imageurl wheel imagepath findfailed
-)
+ADD_SUBDIRECTORY(${JAVA_TEST_DIR})
+
+# Java level tests
+
+SET(MAIN_TEST_SUITE ${PACKAGE}.SikuliScriptTestSuite)
+
+add_custom_target( test-res
+   COMMAND ${CMAKE_COMMAND} -E remove_directory ${CMAKE_BINARY_DIR}/${TEST_RESOURCE_DIR}
+   COMMAND ${CMAKE_COMMAND} -E copy_directory ${BASE_DIR}/${TEST_RESOURCE_DIR} ${CMAKE_BINARY_DIR}/${TEST_RESOURCE_DIR}
+   COMMENT "Copy test resource"
+)
+
+SET(JAVA_TEST_CASE ""
+   CACHE STRING
+   "The java test case to run with run-java-test"
+   )
+
+add_custom_target( run-java-test
+   COMMAND ant -f ${JAVA_TEST_FOR_HUDSON_XML} runtest -Dtest=${JAVA_TEST_CASE}
+   COMMENT "Run specific Java unit tests"
+)
+
+add_dependencies( run-java-test
+        ${JAR_FILE}
+        ${PROJECT_NAME}.test.classes
+        test-res
+)
+
+add_custom_target( java-test
+   COMMAND ant -f ${JAVA_TEST_FOR_HUDSON_XML}
+   COMMENT "Run Java unit tests"
+)
+
+add_dependencies( java-test
+        ${JAR_FILE}
+        ${PROJECT_NAME}.test.classes
+        test-res
+)
+
+
+## Python level tests
 
 SET(PY_TEST_DIR "${BASE_DIR}/src/test/python")
 SET(JYTHON_CLASS org.python.util.jython)
-
-FOREACH(TEST_TARGET ${PYTHON_TESTS})
-   ADD_TEST(Jar_${TEST_TARGET} ${CMAKE_COMMAND} -E chdir ${BASE_DIR} 
-                  java -Dsikuli.Debug=3 -cp ${BINARY_DIR}/${JAR_FILE} 
-                  -Dpython.home=${BINARY_DIR}/${JAR_FILE} 
-                  ${JYTHON_CLASS} ${PY_TEST_DIR}/test-${TEST_TARGET}.py
-   )
-ENDFOREACH(TEST_TARGET)
-
-INCLUDE(CTest)
+SET(JACOCOAGENT_JAR ${BASE_DIR}/../utils/jacoco/lib/jacocoagent.jar)
+IF(WIN32)
+   STRING(REPLACE "/" "\\" JACOCOAGENT_JAR "${JACOCOAGENT_JAR}")
+ENDIF(WIN32)
+SET(JACOCO_ARGS
+   "-javaagent:${JACOCOAGENT_JAR}=destfile=jacoco.exec,includes=org.sikuli.*"
+)
+
+SET(NOSE_ARGS
+   ""
+   CACHE STRING 
+   "The arguments for running Python nose tests")
+
+add_custom_target( python-test
+   COMMAND ${JAVA_RUNTIME} "${JACOCO_ARGS}"  -Dfile.encoding=UTF-8 -Dsikuli.testing=yes -cp "${BINARY_DIR}/${JAR_FILE}${SEP}${TEST_CLASS_DIR}" ${JYTHON_CLASS} ${PY_TEST_DIR}/RunNoseTests.py ${NOSE_ARGS}
+   COMMENT "Run Python unit tests"
+)
+
+add_dependencies( python-test
+   ${JAR_FILE}
+   ${PROJECT_NAME}.test.classes
+   test-res
+)
+
+
+# run all test cases
+add_custom_target( all-test
+)
+
+add_dependencies( all-test
+   java-test
+   python-test
+)

=== sikuli-script/src/main/native/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,5 @@
+# Copyright 2010-2011, Sikuli.org
+# Released under the MIT License.
 ENABLE_LANGUAGE(CXX)
 
 IF(LINUX)
@@ -16,6 +18,7 @@
    org_sikuli_script_VDictProxy.h
    org_sikuli_script_Win32Util.h
    org_sikuli_script_MacUtil.h
+   org_sikuli_script_internal_hotkey_MacHotkeyManager.h
 )
 
 SET(LIBRARY_OUTPUT_PATH ${BINARY_LIB_DIR})
@@ -30,11 +33,15 @@
 INCLUDE(${SWIG_USE_FILE})
 
 # profiling
-#LIST(APPEND CMAKE_CXX_FLAGS "-DENABLE_TIMING")
+#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DENABLE_TIMING")
 # visual logger for debugging
-#LIST(APPEND CMAKE_CXX_FLAGS "-DENABLE_VISUAL_LOG")
+#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DENABLE_VISUAL_LOG")
 # OCR matching debug
-#LIST(APPEND CMAKE_CXX_FLAGS "-DENABLE_OCR_DEBUG")
+#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DENABLE_OCR_DEBUG")
+# enable the debug message in finder
+#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DDEBUG_FINDER")
+# use GPU in template matcher
+#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DENABLE_GPU")
 
 IF(NOT WIN32)
    FIND_PACKAGE(Tesseract REQUIRED)
@@ -68,9 +75,10 @@
 SET(CMAKE_SWIG_FLAGS -package ${NATIVE_PACKAGE})
 SET(SWIG_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
 
-IF(LINUX)
+IF(LINUX OR APPLE)
    FIND_LIBRARY(TIFF_LIBS NAMES tiff)
    LIST(APPEND OpenCV_LIBS ${TIFF_LIBS})
+   LINK_DIRECTORIES(${TIFF_LIB_DIR})
 ENDIF()
 
 SET(BUILD_TARGETS
@@ -88,6 +96,7 @@
    TARGET_LINK_LIBRARIES(Win32Util ${JAVA_AWT_LIBRARY})
 ENDIF()
 
+
 IF(APPLE)
    LIST(APPEND BUILD_TARGETS MacUtil)
    FIND_LIBRARY(JAVA_LIBRARY JavaVM)
@@ -101,17 +110,28 @@
       org_sikuli_script_MacUtil.h
    )
    TARGET_LINK_LIBRARIES(MacUtil ${EXTRA_LIBS})
+
+   LIST(APPEND BUILD_TARGETS MacHotkeyManager)
+
+   ADD_LIBRARY(MacHotkeyManager SHARED
+      MacHotkeyManager.cc
+      sikuli-debug.cpp
+      org_sikuli_script_internal_hotkey_MacHotkeyManager.h
+   )
+   TARGET_LINK_LIBRARIES(MacHotkeyManager ${EXTRA_LIBS})
 ENDIF()
 
 SET(NATIVE_LIBS
    VisionProxy
    ${BUILD_TARGETS}
 )
+message("NATIVE_LIBS: ${NATIVE_LIBS}")
 
 ADD_LIBRARY(VDictProxy SHARED
    VDictProxy.cc
    org_sikuli_script_VDictProxy.h
 )
+TARGET_LINK_LIBRARIES(VDictProxy ${OpenCV_LIBS})
 
 
 ## SWIG: generate a JNI wrapper 
@@ -148,14 +168,10 @@
 
 foreach(BUILD_TARGET ${BUILD_TARGETS})
    TARGET_LINK_LIBRARIES(${BUILD_TARGET} ${OpenCV_LIBS})
-   if(APPLE)
-      set_target_properties(${BUILD_TARGET} PROPERTIES SUFFIX ".jnilib")
-   endif(APPLE)
+   add_dependencies(${BUILD_TARGET} ${PROJECT_NAME}.classes)
+   IF(APPLE)
+      SET_TARGET_PROPERTIES(${BUILD_TARGET} PROPERTIES SUFFIX ".jnilib")
+   ENDIF(APPLE)
 endforeach(BUILD_TARGET ${BUILD_TARGETS})
 
-add_custom_target(${JAR_FILE}.libs-in-jar
-   COMMAND ${CMAKE_COMMAND} -E make_directory ${JAR_DIR}/META-INF
-   COMMAND ${CMAKE_COMMAND} -E copy_directory ${BINARY_LIB_DIR} ${JAR_DIR}/META-INF/lib
-)
-
 add_dependencies(${JAR_FILE}.libs-in-jar ${NATIVE_LIBS})
